#!/bin/bash

ROOT_DIR=/var/www/html/owncloud
DATA_DIR=/home/www-data/var/www/html/owncloud

# RAZ
if [ "$1" == "RAZ" ];then
    . fonctions.sh
    EchoRouge =========================================
    EchoRouge RAZ 
    EchoRouge =========================================
    
    echo "  >> Suppression des anciennes sources"
    rm -rf /var/www/html/owncloud
    rm -rf /home/www-data/var/www/html/owncloud
    
    echo "  >> Suppression de la BDD"
    mysql_pwd.py 123456 root >/dev/null
    echo "DROP DATABASE owncloud;" | mysql -uroot -p123456 -hlocalhost

    echo "  >> Templeting"
    python -c "from creole.reconfigure import templates;templates()" > /dev/null
    
    # Lancer eoledb
    echo "  >> eoleDB"
    /usr/share/eole/posttemplate/01-eoledb >/dev/null
    mysql_pwd.py 123456 root >/dev/null

    echo ""
    EchoRouge =========================================
    EchoRouge INSTALATION 
    EchoRouge =========================================

fi

# Installation de la version 7.0.2
if [ ! -f /var/www/html/owncloud/version.php ];then
    echo "  >> Installation de la version 7.0.2"
    rm -rf /var/www/html/owncloud
    cp -rf /var/www/owncloud/owncloud-7.0.2 ${ROOT_DIR}

    # Modification des droits des fichiers dans l'application
    find ${ROOT_DIR} -type d -exec chmod 750 \{\} \;

    # Modification des droits des fichiers dans l'application
    find ${ROOT_DIR} -type f -exec chmod 640 \{\} \;

    # Attribution des droits spécifiques
    /bin/chmod g+w ${ROOT_DIR}/config
    /bin/chmod u+x ${ROOT_DIR}/occ
    if [ -f "${ROOT_DIR}/config/config.php" ];then
        /bin/chmod g+w ${ROOT_DIR}/config/config.php
    fi
    /bin/chmod g+w ${ROOT_DIR}/apps

    /var/www/html/owncloud/occ upgrade

fi

if [ -f /var/www/html/owncloud/version.php ];then
    owncloudversion=`grep "OC_VersionString" "/var/www/html/owncloud/version.php" | awk -F "'" '{print $2}'`
    if [ "$owncloudversion" == "7.0.2" ];then
        echo "  >> Installation de la version 7.0.12"
        rm -rf /var/www/html/owncloud        
        cp -rf /var/www/owncloud/owncloud-7.0.12 ${ROOT_DIR}
        # Modification des droits des fichiers dans l'application
        find ${ROOT_DIR} -type d -exec chmod 750 \{\} \;

        # Modification des droits des fichiers dans l'application
        find ${ROOT_DIR} -type f -exec chmod 640 \{\} \;

        # Attribution des droits spécifiques
        /bin/chmod g+w ${ROOT_DIR}/config
        /bin/chmod u+x ${ROOT_DIR}/occ
        if [ -f "${ROOT_DIR}/config/config.php" ];then
            /bin/chmod g+w ${ROOT_DIR}/config/config.php
        fi
        /bin/chmod g+w ${ROOT_DIR}/apps

        /var/www/html/owncloud/occ upgrade
    fi
fi

if [ -f /var/www/html/owncloud/version.php ];then
    owncloudversion=`grep "OC_VersionString" "/var/www/html/owncloud/version.php" | awk -F "'" '{print $2}'`
    if [ "$owncloudversion" == "7.0.12" ];then
        echo "  >> Installation de la version 8.0.10"
        rm -rf /var/www/html/owncloud
        cp -rf /var/www/owncloud/owncloud-8.0.10 ${ROOT_DIR}
        # Modification des droits des fichiers dans l'application
        find ${ROOT_DIR} -type d -exec chmod 750 \{\} \;

        # Modification des droits des fichiers dans l'application
        find ${ROOT_DIR} -type f -exec chmod 640 \{\} \;

        # Attribution des droits spécifiques
        /bin/chmod g+w ${ROOT_DIR}/config
        /bin/chmod u+x ${ROOT_DIR}/occ
        if [ -f "${ROOT_DIR}/config/config.php" ];then
            /bin/chmod g+w ${ROOT_DIR}/config/config.php
        fi
        /bin/chmod g+w ${ROOT_DIR}/apps

        /var/www/html/owncloud/occ upgrade
    fi
fi

if [ -f /var/www/html/owncloud/version.php ];then
    owncloudversion=`grep "OC_VersionString" "/var/www/html/owncloud/version.php" | awk -F "'" '{print $2}'`
    if [ "$owncloudversion" == "8.0.10" ];then
        echo "  >> Installation de la version 8.1.5"
        rm -rf /var/www/html/owncloud
        cp -rf /var/www/owncloud/owncloud-8.1.5 ${ROOT_DIR}
        # Modification des droits des fichiers dans l'application
        find ${ROOT_DIR} -type d -exec chmod 750 \{\} \;

        # Modification des droits des fichiers dans l'application
        find ${ROOT_DIR} -type f -exec chmod 640 \{\} \;

        # Attribution des droits spécifiques
        /bin/chmod g+w ${ROOT_DIR}/config
        /bin/chmod u+x ${ROOT_DIR}/occ
        if [ -f "${ROOT_DIR}/config/config.php" ];then
            /bin/chmod g+w ${ROOT_DIR}/config/config.php
        fi
        /bin/chmod g+w ${ROOT_DIR}/apps

        /var/www/html/owncloud/occ upgrade
    fi
fi


if [ -f /var/www/html/owncloud/version.php ];then
    owncloudversion=`grep "OC_VersionString" "/var/www/html/owncloud/version.php" | awk -F "'" '{print $2}'`
    if [ "$owncloudversion" == "8.1.5" ];then
        echo "  >> Installation de la version 8.2.2"
        rm -rf /var/www/html/owncloud
        cp -rf /var/www/owncloud/owncloud-8.2.2 ${ROOT_DIR}
        # Modification des droits des fichiers dans l'application
        find ${ROOT_DIR} -type d -exec chmod 750 \{\} \;

        # Modification des droits des fichiers dans l'application
        find ${ROOT_DIR} -type f -exec chmod 640 \{\} \;

        # Attribution des droits spécifiques
        /bin/chmod g+w ${ROOT_DIR}/config
        /bin/chmod u+x ${ROOT_DIR}/occ
        if [ -f "${ROOT_DIR}/config/config.php" ];then
            /bin/chmod g+w ${ROOT_DIR}/config/config.php
        fi
        /bin/chmod g+w ${ROOT_DIR}/apps

        /var/www/html/owncloud/occ upgrade

        # Activation des app de base
        #/var/www/html/owncloud/occ app:enable calendar
        #/var/www/html/owncloud/occ app:enable tasks
        #/var/www/html/owncloud/occ app:enable documents
        #/var/www/html/owncloud/occ upgrade

    fi
fi

if [ -f /var/www/html/owncloud/version.php ];then
    owncloudversion=`grep "OC_VersionString" "/var/www/html/owncloud/version.php" | awk -F "'" '{print $2}'`
    if [ "$owncloudversion" == "8.2.2" ];then
        echo "  >> Installation de la version 9.0.2"
        rm -rf /var/www/html/owncloud
        cp -rf /var/www/owncloud/owncloud-9.0.2 ${ROOT_DIR}
        # Modification des droits des fichiers dans l'application
        find ${ROOT_DIR} -type d -exec chmod 750 \{\} \;

        # Modification des droits des fichiers dans l'application
        find ${ROOT_DIR} -type f -exec chmod 640 \{\} \;

        # Attribution des droits spécifiques
        /bin/chmod g+w ${ROOT_DIR}/config
        /bin/chmod u+x ${ROOT_DIR}/occ
        if [ -f "${ROOT_DIR}/config/config.php" ];then
            /bin/chmod g+w ${ROOT_DIR}/config/config.php
        fi
        /bin/chmod g+w ${ROOT_DIR}/apps

        /var/www/html/owncloud/occ upgrade

        # Activation des app de base
        /var/www/html/owncloud/occ app:disable activity
        /var/www/html/owncloud/occ app:enable calendar
        /var/www/html/owncloud/occ app:enable tasks
        /var/www/html/owncloud/occ app:enable documents
        /var/www/html/owncloud/occ upgrade
        
        # On replace le htaccess
        cp -rf /var/www/owncloud/owncloud-9.0.2/.htaccess ${ROOT_DIR}/
        
        # Lancer le cron
        echo "  >> Tache CRON"
        php /var/www/html/owncloud/cron.php

    fi
fi

echo "  >> Appliquer Patch Envole"
/bin/cp -rf /var/www/owncloud/owncloud-9.0.2/apps/envole_cas ${ROOT_DIR}/apps
/bin/cp -rf /var/www/owncloud/owncloud-9.0.2/apps/user_ldap ${ROOT_DIR}/apps
/bin/cp -rf /var/www/owncloud/owncloud-9.0.2/core/js/sharedialogview.js ${ROOT_DIR}/core/js
/bin/cp -rf /var/www/owncloud/owncloud-9.0.2/lib/private/files/filesystem.php ${ROOT_DIR}/lib/private/files/filesystem.php

# Attribution des droits minimaux
echo "  >> Permissions"
/bin/chown -R root:www-data ${ROOT_DIR}
/bin/chmod g+w ${ROOT_DIR}/config -R
/bin/chmod u+x ${ROOT_DIR}/occ
/bin/chmod g+w ${ROOT_DIR}/apps -R

echo "  >> Mise à jour"
/var/www/html/owncloud/occ upgrade

/bin/chown -R www-data:www-data ${ROOT_DIR}
/bin/chmod g+w ${ROOT_DIR}/config -R
/bin/chmod u+x ${ROOT_DIR}/occ
/bin/chmod g+w ${ROOT_DIR}/apps -R


# Création du répertoire /home/www-data/var/www/html/owncloud
echo "  >> Création répertoire www-data"
if [ ! -d "/home/www-data/var/www/html/owncloud" ];then
	/bin/mkdir -p /home/www-data/var/www/html/owncloud
fi

if [ ! -d "/home/www-data/var/www/html/owncloud/admin" ];then
    echo "  >> Génération Répertoire admin"
    /bin/mkdir -p /home/www-data/var/www/html/owncloud/admin
    /bin/mkdir -p /home/www-data/var/www/html/owncloud/admin
    /bin/mkdir -p /home/www-data/var/www/html/owncloud/admin/files
    /bin/mkdir -p /home/www-data/var/www/html/owncloud/admin/thumbnails
    
    echo "  >> Rescan des fichiers"
    /bin/cp -R ${ROOT_DIR}/core/skeleton/* /home/www-data/var/www/html/owncloud/admin/files
    /var/www/html/owncloud/occ files:scan --all >/dev/null
fi

/bin/chown -R www-data:www-data ${DATA_DIR}

# Lancer le cron
echo "  >> Tache CRON"
sudo -u www-data php /var/www/html/owncloud/cron.php




